package com.jetbyte.cache3;

import java.util.Map;
import java.util.HashMap;

public class SimpleCache implements Cache
{
   public SimpleCache(String name)
   {
      this.name = name;
   }

   synchronized public Object find(String keyString)
   {
      key.setKey(keyString);

      return find(key);
   }
   
   synchronized public Object find(Cache.Key cacheKey)
   {      
      Object obj = cache.get(cacheKey);

      if (obj == null)
      {
         misses++;
      }
      else
      {
         hits++;
      }

      return obj;
   }

   public void add(String keyString, Object obj)
   {
      add(new Cache.Key(keyString), obj);
   }

   synchronized public void add(Cache.Key cacheKey, Object obj)
   {
      cache.put(cacheKey, obj);
   }

   synchronized public void remove(String keyString)
   {
      key.setKey(keyString);
      
      remove(key);      
   }

   synchronized public void remove(Cache.Key cacheKey)
   {
      cache.remove(cacheKey);
   }

   public String name()
   {
      return name;
   }

   synchronized public int entries()
   {
      return cache.size();
   }

   public int hits()
   {
      return hits;
   }

   public int misses()
   {
      return misses;
   }

   synchronized public void flush()
   {
      cache.clear();
      
      hits = 0;
      misses = 0;
   }

   private final String name;

   private int hits = 0;
   private int misses = 0;

   private Map cache = new HashMap(89);   
   private Cache.Key key = new Cache.Key();   
}
